#include <stdio.h>
#include <math.h>

// only for getch()
#include <conio.h>

const int STRLEN = 1024;
const int BUFLEN = 512;
const double EPS = 1e-10;

int Prior(char c)
{
	switch (c)
	{
	case '+': case '-': return 11;
	case '*': case '/': return 12; 
	case '^': return 13;
	case '[': case ']': return 1;
	case '(': case ')': return 1;
	case '\0': return 0;
	default:  
		printf ("Error #4 (no operators)!!!"); 
		return 0;
	}
}

double Value_Math_String (const char* str)
{
	char operators[BUFLEN];
	int Nop = 0;
	double values[BUFLEN];
	int Nval = 0;
	int i;
	int Fop = 0; // bool Fop = false; -  {-1}  / {0}
	for (i = 0; ; i++) 
	{
		if (str[i] == ' ' || str[i] == '\t' || str[i] == '\n' || str[i] == '\r') continue;
		if (Fop)
		{
			//   . 
			// 
			while (Nop > 0 && operators[Nop-1] != '(' && operators[Nop-1] != '[' && Prior(str[i]) - Prior(operators[Nop-1]) <= 0 )
			{
				switch (operators[Nop-1])
				{
				case '+': Nval--; values[Nval-1] += values[Nval]; break;
				case '-': Nval--; values[Nval-1] -= values[Nval]; break;
				case '*': Nval--; values[Nval-1] *= values[Nval]; break;
				case '/': 
					Nval--; 
					if (fabs(values[Nval]) < EPS)
					{
						printf ("Error #6 (div 0)!!!"); 
						return 0;
					}
					values[Nval-1] /= values[Nval]; break;
				case '^': 
					Nval--; 
					//if (values[Nval-1] < 0)
					//{
					//	printf ("Error #8 (pow(-x, y))!!!"); 
					//	return 0;
					//}
					if (fabs(values[Nval-1]) < EPS && values[Nval] < 0)
					{
						printf ("Error #7 (pow(0, -x))!!!"); 
						return 0;
					}
					values[Nval-1] = pow(values[Nval-1], values[Nval]); break;
				default:
					printf ("Error #4 (no operators)!!!"); 
					return 0;
				}
				Nop--;
			}
			if (Nop>0 && 
				  (
					(operators[Nop-1] == '(' && str[i] == ')')  ||	
					(operators[Nop-1] == '[' && str[i] == ']')
				  )
				) { Nop--; continue;}
			else Fop = !Fop;
			// 
			if (Nop < BUFLEN) 
			{ 
				operators[Nop] = str[i];
				Nop++; 
			} // operators[Nop++] = str[i];   operators[++Nop] = str[i];
			else 
			{
				printf ("Error #3 (operators)!!!"); //   operators
				return 0;
			}
		}
		else
		{
			//     
			if (str[i] == '(' || str[i] == '[')
			{
				if (Nop < BUFLEN) 
				{ 
					operators[Nop] = str[i];
					Nop++; 
				} // operators[Nop++] = str[i];   operators[++Nop] = str[i];
				else 
				{
					printf ("Error #3.5 (operators)!!!"); //   operators
					return 0;
				}
			}
			else
			{
				double x = 0;
				int m = 0;
				if (str[i] == '-') {m = 1; i++;}
				else if (str[i] == '+') {m = 0; i++;}

				int j = i;
				for (; str[i]>='0' && str[i]<='9'; i++)
				{
					x = x*10 + (str[i] - '0');
				}
				if (str[i] == '.' || str[i] == ',')
				{
					i++;
					double p = 0.1;
					for (; str[i]>='0' && str[i]<='9'; i++)
					{
						x += p*(str[i] - '0');
						p /= 10;
					}
				}
				if (m) x *= -1;

				if (i == j) 
				{
					printf ("Error #1 (no value)!!!"); //   
					return 0;
				}

				if (Nval < BUFLEN) 
				{ 
					values[Nval] = x;
					Nval++; 
				} // values[Nval++] = x;   values[++Nval] = x;
				else 
				{
					printf ("Error #2 (values)!!!"); //   values
					return 0;
				}
				Fop = !Fop;
				i--;
			}
		}
		if (str[i] == '\0') break;
	}

	if (Nval == 1 && Nop == 1) return values[0];
	
	printf ("Error #10 (values)!!!");
	return 0;
}

void PrintValue(const char* str, const char* str2 = NULL)
{
	if (!str) return;
	if (str2) 
		printf ("x = %10s = %10.5f (= %s)\n", str, Value_Math_String (str), str2);
	else
		printf ("x = %10s = %10.5f\n", str, Value_Math_String (str));
}

int main(void)
{
	char str[STRLEN] = "";
	PrintValue ("[2+2]*3", "12");
	printf ("\t\t\t\tTest:\n");
	printf ("\t\t\t\t\t1) +:\n");
	PrintValue ("2+2", "4");
	printf ("\t\t\t\t\t2) -:\n");
	PrintValue ("4-2", "2");
	printf ("\t\t\t\t\t3) *:\n");
	PrintValue ("4*2", "8");
	printf ("\t\t\t\t\t4) /:\n");
	PrintValue ("4/2", "2");
	PrintValue ("4/0", "Error");
	printf ("\t\t\t\t\t5) precedence, ():\n");
	PrintValue ("2+2*3", "8");
	PrintValue ("(2+2)*3", "12");
	PrintValue ("(2+2*3", "Error");
	PrintValue ("2+2)*3", "Error");
	PrintValue ("(2+2)(3)", "Error");
	printf ("\t\t\t\t\t6) values:\n");
	PrintValue ("2", "2");
	PrintValue ("-2", "-2");
	PrintValue ("2.343", "2.343");
	PrintValue (".343", ".343");
	PrintValue ("3.", "3.");
	PrintValue ("3.4.5", "Error");
	PrintValue ("2.1-2.53", "-0.43");
	PrintValue ("-2.53+2.1", "-0.43");
	printf ("\t\t\t\t\t7) space:\n");
	PrintValue ("2 + 2", "4");
	printf ("\t\t\t\t\t8) quest:\n");
	printf ("x = ");
	gets(str);
	PrintValue (str);
	getch();
	return 0;
}